/*kahe massiivi jrjestamine korraga*/
/*jrjestame ndalapevad vastavalt hutemperatuuridele*/

/*Kasutame jrgmisi funktsioone:                                      */
/*   - funktsioon ndalapevade ja temperatuuride vljastamiseks      */
/*   - funktsioon kahe numbri (INT) vahetamiseks vektoris             */
/*   - funktsioon kahe sne (CHAR []) vahetamiseks vektoris           */
/*                (vahetatakse etteantud aadressite vrtused)        */
/*   - funktsioon mullsortimise (Bubble Sort) realiseerimiseks,       */
/*                kasutab eelmist kahte funktsiooni                   */

#include <stdio.h>
#include <string.h>

#define NADP 7   /*kokku pevi ndalas*/

void info_ekraanile(char* [], int [], int);
void  mull_sort(char* [], int [], int);
void vaheta_nimed(char *a[], int , int );
void vaheta_elemendid(int [], int , int );

int main(void)
{
    /*massiiv ndalapevade nimedega*/
    char *nadal[NADP]={"Esmaspaev", "Teisipaev", "Kolmapaev","Neljapaev","Reede","Laupaev", "Pyhapaev"};
    
    /*massiiv hutemperatuuridega*/
    int temp_nadal[NADP]={3,5,2,7,5,8,1};
    
    int i, j; /*tsklimuutujad*/
    int abi;
    char *abi_tekst;
    
    /*elementide vljastamine ekraanile*/
    info_ekraanile(nadal, temp_nadal, NADP);
    
    /*jrjestamine mullsortimise (Bubble Sort) abil*/
    mull_sort(nadal, temp_nadal, NADP);

    /*elementide vljastamine ekraanile*/    
    info_ekraanile(nadal, temp_nadal, NADP);             
    
    
    return 0;
}                                                      

void info_ekraanile(char *nad[], int temp[], int arv)
{
    int i; /*lokaalne muutuja; tsklimuutuja*/ 
    
    for(i=0; i<arv; i++)
    {
             printf("%12s %3d \n",nad[i],temp[i]);
    }         

    /*reavahetus*/
    printf("\n");
}

void  mull_sort(char *nad[], int temp[], int arv)
{
      int i, j; /*tsklimuutujad; lokaalsed*/
      
      for(i=1; i<arv; i++)
      {
          for(j=0; j<arv-1; j++)
          {
             /*kuna jrjestamine toimub hutemperatuuri jrgi*/
             /*siis vrdlemegi hutemperatuure*/
             if (temp[j]>temp[j+1])
             {
                 /*vahetame elemendid MLEMAS massiivis*/
                 vaheta_elemendid(temp, j, j+1);
                 vaheta_nimed(nad, j, j+1);
             }
          }
       }           
} 


/*funktsioon kahe elemendi asukoha vahetamiseks SMBOLMASSIIVIS*/
/*parameetrid: snede vektor, elemenetide arv vektoris         */
/*             vahetatavate elementide asukohad                */
void vaheta_nimed(char *a[], int pos1, int pos2)
{
     char *temp;
          
     temp=a[pos1];    
     a[pos1]=a[pos2];
     a[pos2]=temp;
} 

/*funktsioon kahe elemendi asukoha vahetamiseks*/
/*parameetrid: vektor, elemenetide arv vektoris*/
/*             vahetatavate elementide asukohad*/
void vaheta_elemendid(int numbrid[], int a1, int a2) 
{
    int abi; /*abimuutuja elementide vahetamiseks; lokaalne muutuja*/ 

    /*vahetame elemendid*/
    abi=numbrid[a1];
    numbrid[a1]=numbrid [a2];
    numbrid[a2]=abi;
     
}

